config/routes.rb
Rails.application.routes.draw do
  devise_for :users, :controllers => { :omniauth_callbacks => "users/omniauth_callbacks" }
  root to: 'pages#dashboard'
  namespace :cv do
    root to: 'pages#dashboard'
    resources :profiles
    resources :work_experiences
    resources :educations
    resources :certificates
    resources :skills
  end
  namespace :inspiration do
    root to: 'pages#dashboard'
    resources :technologies
    resources :tools
  end

  namespace :blog do
    root to: 'pages#dashboard'
    resources :articles
  end

end

app/models/work_experience.rb
class WorkExperience < ActiveRecord::Base
  belongs_to :user
end

app/controllers/cv/certificates_controller.rb
class Cv::CertificatesController < ApplicationController
  before_action :set_title

  def index

  end

  private
  def set_title
    @title = 'Certificaten'
  end
end

app/controllers/cv/educations_controller.rb
class Cv::EducationsController < ApplicationController
  before_action :set_title

  def index

  end

  private
  def set_title
    @title = 'Opleidingen'
  end
end

app/controllers/cv/pages_controller.rb
class Cv::PagesController < ApplicationController
  before_action :set_title

  def dashboard
  end

  private
  def set_title
    @title = 'Curriculum Vitae'
  end
end

app/controllers/cv/profiles_controller.rb
class Cv::ProfilesController < ApplicationController
  before_action :set_title

  def index
  end

  def show
    @profile = current_user.profile
  end

  def new
    @profile = Profile.new
  end

  def create
    @profile = Profile.new(profile_params)
    @profile.user_id = current_user.id
    if @profile.save
      redirect_to cv_profiles_path
    else
      render :new
    end
  end

  def edit
  end

  def update
  end

  def destroy
  end

  private

  def set_title
    @title = 'Mijn Profiel'
  end

  def profile_params
    params.require(:profile).permit(:firstname, :lastname, :email,  :date_of_birth, :mobile)
  end

end

app/controllers/cv/skills_controller.rb
class Cv::SkillsController < ApplicationController
  before_action :set_title

  def index

  end

  private
  def set_title
    @title = 'Skills'
  end
end

app/controllers/cv/work_experiences_controller.rb
class Cv::WorkExperiencesController < ApplicationController
  before_action :set_title
  helper_method :sort_column, :sort_direction

  def index
    @work_experiences = WorkExperience.all
  end

  def show
    @work_experience = WorkExperience.find(params[:id])
  end

  def new
    @work_experience = WorkExperience.new
  end

  def create
    @work_experience = WorkExperience.new(work_experience_params)
    @work_experience.user_id = current_user.id
    if @work_experience.save
      redirect_to cv_work_experiences_path
    else
      render :new
    end
  end

  def edit
  end

  def update
  end

  def destroy
  end

  private

  def work_experience_params
    params.require(:work_experience).permit(:job_title, :start_date, :end_date, :description)
  end

  def set_title
    @title = 'Mijn Werkervaringen'
  end

  def sortable_columns
    ["name", "price"]
  end

  def sort_column
    sortable_columns.include?(params[:column]) ? params[:column] : "name"
  end

  def sort_direction
    %w[asc desc].include?(params[:direction]) ? params[:direction] : "asc"
  end

end

app/helpers/work_experience_helper.rb
module WorkExperienceHelper
  def sort_link(column, title = nil)
    title ||= column.titleize
    direction = column == sort_column && sort_direction == "asc" ? "desc" : "asc"
    icon = sort_direction == "asc" ? "glyphicon glyphicon-chevron-up" : "glyphicon glyphicon-chevron-down"
    icon = column == sort_column ? icon : ""
    link_to "#{title} <span class='#{icon}'></span>".html_safe, {column: column, direction: direction}
  end
end

app/views/cv/work_experiences/_form.html.haml
= link_to t('actions.back'), :back, class: 'form-control btn btn-primary col-1'
%hr
= form_with scope:  :work_experience, url: cv_work_experiences_path do |f|
  = f.label :job_title
  = f.text_field :job_title, class: 'form-control col-12 col-md-6'

  = f.label :start_date
  = f.text_field :start_date, data: { provide: 'datepicker'}, class: 'datepicker form-control col-12 col-md-6'

  = f.label :end_date
  = f.text_field :end_date, class: 'datepicker form-control col-12 col-md-6'

  = f.label :description
  = f.text_area :description, class: 'form-control col-12 col-md-6'

  = f.submit t('actions.submit'), class: 'form-control btn btn-primary col-2'

:javascript
  $(document).ready(function(){
    $('.datepicker').datepicker({
      changeMonth: true,
      changeYear: true
    });
  });

app/views/cv/work_experiences/index.html.haml
= link_to "#{t('actions.new')}", new_cv_work_experience_path, class: 'btn success-color create-btn'
= render "shared/cv_nav.html.haml"
%br

%table.table.table-hover
  %thead.default-color-dark
    %tr
      %th= sort_link "Functie"
      %th= sort_link "Start datum"
      %th= sort_link "Eind datum"
      %th= sort_link "Beschrijving"
  %tbody
  - @work_experiences.each do |w|
    %tr{data: { link: cv_work_experience_path(w) }}
      %td= w.job_title
      %td= w.start_date
      %td= w.end_date
      %td= w.description

:javascript
  $("tr[data-link]").click(function() {
    window.location = $(this).data("link")
  })

app/views/cv/work_experiences/new.html.haml
= render "form"